#ifndef MENU_H_INCLUDED
#define MENU_H_INCLUDED
#endif // MENU_H_INCLUDED

void disp_menu()
{
    buttons_pressed = get_buttons();
    if(menu_pos != old_menu_pos)
    {
        lcd_setcursor(0,old_menu_pos-menu_pos2);
        lcd_writedata();
        lcd_send(' ');
        old_menu_pos = menu_pos;
    }


    if (buttons_pressed & BTN_UP) // down button - decrease menu pos.
    {
        if (menu_pos > 1) menu_pos--;
        if (menu_pos < menu_pos2)
        {
            menu_pos2--;
            print_menu(str_menu_items, menu_pos2);
        }
    }

    if  (buttons_pressed & BTN_DOWN) // up button - increase menu pos.
    {
        if (menu_pos < 4) menu_pos++;
        if (menu_pos > menu_pos2 + 3)
        {
            menu_pos2++;
            print_menu(str_menu_items, menu_pos2);
        }
    }

    if (buttons_pressed & BTN_OK) // OK button - action.
    {
        switch(menu_pos){
            default:break;
            case 4: // Settings menu
                lcd_sendstring("IMHO LOL", 8);
                while(1);
                break;
            case 3: // Internal resistance measurement
                stat |= stat_inside_submenu;
                rin_submenu();
                break;
            case 2: // Constant current load
                stat |= stat_inside_submenu;
                cc_submenu();
                break;
            case 1: // Measure capacity
                stat |= stat_inside_submenu;
                cap_submenu();
                break;
        }
    }

    lcd_setcursor(0,menu_pos-menu_pos2);
    lcd_writedata();
    lcd_send('>');


}


void rin_submenu()
{
    stat |= stat_inside_submenu;

    lcd_clear();
    lcd_print_pmem_setpos(str_rin_subm1, 20, 0, 0);
    lcd_print_pmem_setpos(str_rin_subm2, 14, 0, 1);
    current_string(buf, i1);
    lcd_sendstring(buf, 5);
    lcd_print_pmem_setpos(str_rin_subm3, 14, 0, 2);
    current_string(buf, i2);
    lcd_sendstring(buf, 5);
    lcd_print_pmem_setpos(str_rin_subm4, 20, 0, 3);

    while(1)
    {
        buttons_pressed = get_buttons();
        if (buttons_pressed & BTN_OK)
        {
            break;
        }
        else if (buttons_pressed & BTN_ESC)
        {
            escape_to_menu();
            return;
        }
        else if ((buttons_pressed & BTN_DOWN) || (buttons_pressed & BTN_UP))
        {
            if ((buttons_pressed & BTN_UP) && rin_current_choice < 9) rin_current_choice++;
            if ((buttons_pressed & BTN_DOWN) && rin_current_choice > 0) rin_current_choice--;
            i1 = pgm_read_byte_near(rin_current1+rin_current_choice);
            i2 = pgm_read_byte_near(rin_current2+rin_current_choice);
            lcd_setcursor(14, 1);
            current_string(buf, i1);
            lcd_sendstring(buf, 5);
            lcd_setcursor(14, 2);
            current_string(buf, i2);
            lcd_sendstring(buf, 5);
        }
    }

    stat &= stat_inside_submenu;
    stat &= stat_inside_menu;

    rin_test();
}

void cc_submenu()
{
    stat |= stat_inside_submenu;

    lcd_clear();
    lcd_print_pmem_setpos(str_ccl_subm1, 20, 0, 0);
    lcd_print_pmem_setpos(str_current, 9, 0, 1);
    current_string(buf, pwm_current);
    lcd_sendstring(buf, 5);

    submenu_stat = 1;

    uint8_t xpos;

    lcd_writecmd();
    lcd_send(LCD_ONOFF | LCD_ONOFF_DISPLAY | LCD_ONOFF_BLINK);

    lcd_setcursor(12, 1);

    while(1)
    {
        buttons_pressed = get_buttons();
        if (buttons_pressed & BTN_ESC)
        {
            submenu_stat--;
            if (submenu_stat == 0)
            {
                escape_to_menu();
                break;
            }

            if (submenu_stat>0 && submenu_stat<4) // current field
            {
                xpos = 13 - submenu_stat;
                if (submenu_stat >= 3) xpos--;
                lcd_setcursor(xpos, 1);
            }

        }
        if (buttons_pressed & BTN_OK)
        {
            submenu_stat++;
            if (submenu_stat>=0 && submenu_stat<4) // current field
            {
                xpos = 13 - submenu_stat;
                if (submenu_stat >= 3) xpos--;
                lcd_setcursor(xpos, 1);
            }
            if (submenu_stat >= 4)
            {
                lcd_writecmd();
                lcd_send(LCD_ONOFF | LCD_ONOFF_DISPLAY);
                lcd_clear();
                lcd_print_pmem_setpos(str_esc_exit, 20, 0, 3); // escape command
                stat &= ~(stat_inside_submenu | stat_inside_menu);
                stat |= stat_ccload_enabled;
                enable_wdt();
                set_current(pwm_current);
                enable_1s_timer();
                return;
            }
        }
        if ((buttons_pressed & BTN_UP) || (buttons_pressed & BTN_DOWN))
        {
            if (buttons_pressed & BTN_UP)
            {
                if(submenu_stat==3 && pwm_current < 156) pwm_current += 100;
                if(submenu_stat==2 && pwm_current < 246) pwm_current += 10;
                if(submenu_stat==1 && pwm_current < 255) pwm_current += 1;

            }
            if (buttons_pressed & BTN_DOWN)
            {
                if(submenu_stat==3 && pwm_current > 100) pwm_current -= 100;
                if(submenu_stat==2 && pwm_current > 10) pwm_current -= 10;
                if(submenu_stat==1 && pwm_current > 1) pwm_current -= 1;
            }
            lcd_setcursor(9,1);
            current_string(buf, pwm_current);
            lcd_sendstring(buf, 5);
            xpos = 13 - submenu_stat;
            if (submenu_stat == 3) xpos--;
            lcd_setcursor(xpos, 1);
        }

    }
}

void cap_submenu()
{
    stat |= stat_inside_submenu;

    lcd_clear();
    lcd_print_pmem_setpos(str_submenu_disch, 20, 0, 0);
    lcd_print_pmem_setpos(str_current, 9, 0, 1);
    current_string(buf, pwm_current);
    lcd_sendstring(buf, 5);
    lcd_print_pmem_setpos(str_term_v, 9, 0, 2);
    voltage_string(buf, term_voltage);
    lcd_sendstring(buf, 6);
    lcd_print_pmem_setpos(str_back_next, 20, 0, 3);

    lcd_writecmd();
    lcd_send(LCD_ONOFF | LCD_ONOFF_DISPLAY | LCD_ONOFF_BLINK);

    lcd_setcursor(12,1);

    field = 0;

    submenu_stat = 1;

    uint8_t xpos=0;

    while(1)
    {
        buttons_pressed = get_buttons();
        if (buttons_pressed & BTN_ESC)
        {
            submenu_stat--;
            if (submenu_stat == 0)
            {
                escape_to_menu();
                break;
            }

            if (submenu_stat>0 && submenu_stat<4) // current field
            {
                field = 0;
                xpos = 13 - submenu_stat;
                if (submenu_stat >= 3) xpos--;
                lcd_setcursor(xpos, field+1);
            }

            if (submenu_stat>3 && submenu_stat<8) // voltage field
            {
                field = 1;
                xpos = 17 - submenu_stat;
                if (submenu_stat >= 6) xpos--;
                lcd_setcursor(xpos, field+1);
            }

        }
        if (buttons_pressed & BTN_OK)
        {
            submenu_stat++;
            if (submenu_stat>=0 && submenu_stat<4) // current field
            {
                field = 0;
                xpos = 13 - submenu_stat;
                if (submenu_stat >= 3) xpos--;
                lcd_setcursor(xpos, field+1);
            }

            if (submenu_stat>3 && submenu_stat<8) // voltage field
            {
                field = 1;
                xpos = 17 - submenu_stat;
                if (submenu_stat >= 6) xpos--;
                lcd_setcursor(xpos, field+1);
            }
            if (submenu_stat >= 8) // start discharge
            {
                _delay_ms(8);
                lcd_writecmd();
                lcd_send(LCD_ONOFF | LCD_ONOFF_DISPLAY);
                lcd_clear();
                stat &= ~(stat_inside_submenu | stat_inside_menu);
                stat |= stat_disch_enabled;
                _delay_ms(8);
                set_current(pwm_current);
                enable_1s_timer();
                enable_wdt();
                return;
            }
        }
        if ((buttons_pressed & BTN_UP) || (buttons_pressed & BTN_DOWN))
        {
            if (buttons_pressed & BTN_UP)
            {
                if(submenu_stat==3 && pwm_current < 156) pwm_current += 100;
                if(submenu_stat==2 && pwm_current < 246) pwm_current += 10;
                if(submenu_stat==1 && pwm_current < 255) pwm_current += 1;
                if(submenu_stat==7 && term_voltage < 1047) term_voltage += 1000;
                if(submenu_stat==6 && term_voltage < 1947) term_voltage += 100;
                if(submenu_stat==5 && term_voltage < 2037) term_voltage += 10;
                if(submenu_stat==4 && term_voltage < 2046) term_voltage += 1;
            }
            if (buttons_pressed & BTN_DOWN)
            {
                if(submenu_stat==3 && pwm_current > 100) pwm_current -= 100;
                if(submenu_stat==2 && pwm_current > 10) pwm_current -= 10;
                if(submenu_stat==1 && pwm_current > 1) pwm_current -= 1;
                if(submenu_stat==7 && term_voltage > 1079) term_voltage -= 1000;
                if(submenu_stat==6 && term_voltage > 179) term_voltage -= 100;
                if(submenu_stat==5 && term_voltage > 89) term_voltage -= 10;
                if(submenu_stat==4 && term_voltage > 80) term_voltage -= 1;
            }
            if (submenu_stat < 4)
            {
                lcd_setcursor(9,1);
                current_string(buf, pwm_current);
                lcd_sendstring(buf, 5);
                xpos = 13 - submenu_stat;
                if (submenu_stat == 3) xpos--;
                lcd_setcursor(xpos, field+1);
            }
            else
            {
                lcd_setcursor(9,2);
                voltage_string(buf, term_voltage);
                lcd_sendstring(buf, 6);
                xpos = 17 - submenu_stat;
                if (submenu_stat >= 6) xpos--;
                lcd_setcursor(xpos, field+1);
            }
        }
    }
}

void escape_to_menu()
{
    disable_wdt();
    asm("WDR");
    cli();
    set_current(0);
    disable_1s_timer();
    sei();
    lcd_writecmd();
    lcd_send(LCD_ONOFF | LCD_ONOFF_DISPLAY);

    stat = 0;
    menu_pos = 1;
    menu_pos2 = 0;
    lcd_clear();
    print_menu(str_menu_items, menu_pos2);
    stat |= stat_inside_menu;
}

void print_menu(const char * str_menu_items[], uint8_t position)
{
    lcd_print_pmem_setpos(str_select0, 20, 0, 0);
    lcd_print_pmem_setpos(str_menu_items[0+position], 20, 0, 1);
    lcd_print_pmem_setpos(str_menu_items[1+position], 20, 0, 2);
    lcd_print_pmem_setpos(str_menu_items[2+position], 20, 0, 3);
}

